stages:
  - build
  - deploy

build:
  stage: build
  image: docker
  services:
    - docker:dind
  script:
    - docker build -t ${USERNAME}/cicd-frontend:${CI_COMMIT_SHORT_SHA} .
    - docker images
    - echo "$PASSWORD" | docker login -u ${USERNAME} --password-stdin
    - docker push ${USERNAME}/cicd-frontend:${CI_COMMIT_SHORT_SHA}  

deploy: 
  stage: deploy
  image: kroniak/ssh-client
  script:
    - echo "$SSH_PRIVATE_KEY" > key.pem
    - chmod  400 key.pem
    - eval $(ssh-agent -s)
    - ssh-add key.pem
    - ssh -o StrictHostKeyChecking=no ubuntu@${EC2_IP} "docker stop frontend && docker rm frontend  && docker run -d -p 80:80 --name frontend mahamudulchowdry/cicd-frontend:${CI_COMMIT_SHORT_SHA}"

